unit cartruco;

interface

uses
  SysUtils, Classes, QGraphics, QControls,
  QForms, QDialogs, Carta;

type
  TCartaTruco = class(TCarta)
  private
    intJogador : integer;
    boolVirada : boolean;
    intMao : integer;
    function lePeso : integer;
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
{    procedure Move(x,y : integer);}
    constructor Create(AOwner : TComponent); override;
  published
    { Published declarations }
    property Jogador : integer read intJogador write intJogador;
    property Peso : integer read lePeso;
    property Mao : integer read intMao write intMao;
    property Virada : boolean read boolVirada write boolVirada;
  end;

const
  PESO_A = 85;
  PESO_2 = 89;
  PESO_3 = 93;
  PESO_4 = 17;
  PESO_5 = 21;
  PESO_6 = 25;
  PESO_7 = 29;
  PESO_8 = 33;
  PESO_9 = 37;
  PESO_10 = 41;
  PESO_J = 49;
  PESO_Q = 45;
  PESO_K = 53;

procedure Register;

implementation

constructor TCartaTruco.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  Jogador := 0;
  Mao := 0;
  Virada := false;
end;


{ d um peso arbitrrio a uma carta, considerando se ela e o zap (virada) }
function TCartaTruco.lePeso : integer;
var
  vr, nr : integer; {valor e naipe reais}
begin
  case naipe of
    1 {ouro}    : nr := 1;  {provisorio - achar a ordem correta dos naipes !!!}
    3 {espadas} : nr := 2;
    2 {copas}   : nr := 3;
    4 {paus}    : nr := 4;
  end;
  if not boolVirada then
    begin
      { coloca os A,2,3 na frente }
      if (valor < 4) then
        vr := valor+20
      else
        vr := valor;
      if valor = 11 then vr := 12; { inverte J e Q }
      if valor = 12 then vr := 11;
      lePeso := vr*4 + nr;      { inclui o naipe na conta }
    end
  else { coloca a carta virada (zap?) na frente de tudo }
    lePeso := 100+nr;            { inclui o naipe na conta }
end;

procedure Register;
begin
  RegisterComponents('Truco', [TCartaTruco]);
end;

end.
