unit mesa;

interface

uses
  SysUtils, Classes, QGraphics, QControls,
  QForms, QDialogs, carta, cartruco,
  QExtCtrls, QMenus, QTypes, QStdCtrls, QButtons;

type
  TformMesa = class(TForm)
    cartaBaralho4: TCarta;
    cartaBaralho3: TCarta;
    cartaBaralho2: TCarta;
    cartaBaralho1: TCarta;
    MainMenu1: TMainMenu;
    Jogo1: TMenuItem;
    NovoJogo1: TMenuItem;
    panelMesa: TPanel;
    timerJogo: TTimer;
    panelMensagem: TPanel;
    timerMensagem: TTimer;
    btnTruco: TBitBtn;
    btnQueima: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Sair1: TMenuItem;
    timerIndicaJogador: TTimer;
    Ajuda1: TMenuItem;
    SobreoTrucoLadro1: TMenuItem;
    N2: TMenuItem;
    EscolherBaralho1: TMenuItem;
    N3: TMenuItem;
    timerTruco: TTimer;
    panelDebug: TPanel;
    btnDebugDesiste: TButton;
    btnDebugAceita: TButton;
    btnDebugTruca: TButton;
    editNumJog: TEdit;
    labelDebug1: TLabel;
    labelDebug2: TLabel;
    AlternaDebug: TMenuItem;
    N1: TMenuItem;
    procedure FormResize(Sender: TObject);
    procedure NovoJogo1Click(Sender: TObject);
    procedure cartaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure timerJogoTimer(Sender: TObject);
    procedure timerMensagemTimer(Sender: TObject);
    procedure btnTrucoClick(Sender: TObject);
    procedure btnQueimaClick(Sender: TObject);
    procedure timerIndicaJogadorTimer(Sender: TObject);
    procedure Sair1Click(Sender: TObject);
    procedure EscolherBaralho1Click(Sender: TObject);
    procedure btnDebugTrucaClick(Sender: TObject);
    procedure timerTrucoTimer(Sender: TObject);
    procedure btnDebugAceitaClick(Sender: TObject);
    procedure btnDebugDesisteClick(Sender: TObject);
    procedure AlternaDebugClick(Sender: TObject);
    procedure SobreoTrucoLadro1Click(Sender: TObject);
  private
    procedure Inicializa;
    procedure MoveCarta(carta : TCartaTruco; x, y : integer);
    procedure MandaPraMesa(Sender : TCartaTruco);
//    procedure WMGetMinMaxInfo(var M: TWMGetMinMaxInfo); message WM_GETMINMAXINFO;
    procedure Mensagem(s : string);
    procedure PiscaMensagem(cor : TColor);
    procedure AceitaTruco(jogador : integer);
    procedure Desiste(jogDesistente : integer);
    function FazJogada(jog : integer) : TCartaTruco;
    procedure PedeTruco(intJogador : integer);
    function AvaliaTruco(jog : integer) : boolean;
    procedure ArregaTruco(jog : integer);
  public
    { Public declarations }
  end;

const

  J_BEN = 2;
  J_RUI = 3;
  J_JUD = 4;

var
  formMesa: TformMesa;
  daVezJogou : boolean;
  sorteada : array[1..13,1..4] of boolean;
  intMaoAtual, pontosValendo,
  intJogadorAtual, intJogadorDaVez,
  intTamMinMesa, intJogAbreRodada,
  intMaosD1, intMaosD2,
  ultCartaX, ultCartaY,
  intPontosD1, intPontosD2 : integer;
  PosCartas : array[1..4] of record
                               x,y : integer;
                             end;
  tempoMin : integer;
  desistiu : array[1..4] of boolean;
  arregouTruco : array[1..4] of boolean;
  nomes : array[1..4] of string;
  tipoJog : array[1..4] of integer;
  autoNovoJogo, boolPisca : boolean;
  menorCarta : TCartaTruco;
  intJogadorTrucando : integer; { Jogador que est pedindo truco, 6, 9...}
  intUltimoTrucador : integer; { Jogador que pediu o ltimo truco, 6, 9...}
  inicializando : boolean;

implementation

{$R *.xfm}
uses entrnome, vitoria, escolbar;

procedure pause(intTempo : integer);
var
  datetimeTemp : TDateTime;
begin
  datetimeTemp := Now;
  while Now - datetimeTemp < (intTempo / 86000000) do ;
end;

{ procedure tformMesa.WMGetMinMaxInfo(var M: TWMGetMinMaxInfo);
begin
  M.MinMaxInfo.ptMinTrackSize.x := intTamMinMesa;
  M.MinMaxInfo.ptMinTrackSize.y := intTamMinMesa;
end; }

procedure TformMesa.FormResize(Sender: TObject);
var
  c : TComponent;
  jogador,carta,
  desvioX, desvioY : integer;
begin
  Screen.Cursor := crHourGlass;
  CartaBaralho1.Top := ClientHeight - 143;
  CartaBaralho2.Top := CartaBaralho1.Top + 4;
  CartaBaralho3.Top := CartaBaralho2.Top + 4;
  CartaBaralho4.Top := CartaBaralho3.Top + 4;
  posCartas[1].y := ClientHeight - 129;
  posCartas[1].x := (ClientWidth - 100) div 2;

  posCartas[2].y := (ClientHeight - 96) div 2;
  posCartas[2].x := ClientWidth - 112;

  posCartas[3].y := 10;
  posCartas[3].x := (ClientWidth - 100) div 2;

  posCartas[4].y := (ClientHeight - 96) div 2;
  posCartas[4].x := 10;

  desvioX := ((ClientWidth - panelMesa.Width) div 2 ) - panelMesa.Left;
  desvioY := ((ClientHeight - panelMesa.Height) div 2 ) - panelMesa.Top;

  label1.top := posCartas[1].y+82;
  label1.left := posCartas[1].x+101;

  label2.left := ClientWidth-label2.width-8;
  label2.top := posCartas[2].y - 16;

  label3.top := posCartas[3].y+2;
  label3.left := posCartas[3].x-label3.width;

  label4.left := posCartas[4].x;
  label4.top := posCartas[4].y+99;

  for jogador := 1 to 5 do
    for carta := 1 to 3 do
      begin
        c := FindComponent('J'+intToStr(jogador)+'C'+IntToStr(carta));
        if c <> nil then
          if TCartaTruco(c).mao = 0 then
            begin
              TCartaTruco(c).Left := posCartas[jogador].x+(carta-1)*14;
              TCartaTruco(c).Top := posCartas[jogador].y;
            end
          else
            if Jogador = 5 then
              begin
                TCartaTruco(c).Left := cartaBaralho4.Left +40;
                TCartaTruco(c).Top := cartaBaralho4.top;
              end
            else
              if not Desistiu[Jogador] then
                begin
                  TCartaTruco(c).Left := TCartaTruco(c).Left + desvioX;
                  TCartaTruco(c).Top := TCartaTruco(c).Top + desvioY;
                end
              else
                begin
                  TCartaTruco(c).Mostrar := false;
                  TCartaTruco(c).Top := CartaBaralho1.Top;
                  TCartaTruco(c).Left := CartaBaralho1.Left;
                end;
      end;

  panelMesa.Left := (ClientWidth - panelMesa.Width) div 2;
  panelMesa.Top := (ClientHeight - panelMesa.Height) div 2;

  btnTruco.Left := ClientWidth - btnTruco.Width - 8;
  btnTruco.Top := ClientHeight - btnTruco.Height - 8 - panelMensagem.Height;
  btnQueima.Left := btnTruco.Left;
  btnQueima.Top := btnTruco.Top - 40;
  screen.Cursor := crDefault;

end;

procedure TformMesa.NovoJogo1Click(Sender: TObject);
begin
  timerJogo.Enabled := false;
  timerTruco.Enabled := false;
  if autoNovoJogo or (formEntraNome.ShowModal = mrOk) then
    begin
      autoNovoJogo := false;
      nomes[1] := formEntraNome.editNome.Text;
      nomes[2] := formEntraNome.editInt1.Text;
      nomes[3] := formEntraNome.cbParceiro.Text;
      nomes[4] := formEntraNome.editInt2.Text;
      tipoJog[1] := 1;
      case formEntraNome.cbParceiro.ItemIndex of
        0 : begin
              tipoJog[2] := J_BEN;
              tipoJog[3] := J_RUI;
              tipoJog[4] := J_JUD;
            end;
        1 : begin
              tipoJog[2] := J_RUI;
              tipoJog[3] := J_BEN;
              tipoJog[4] := J_JUD;
            end;
        2 : begin
              tipoJog[2] := J_JUD;
              tipoJog[3] := J_BEN;
              tipoJog[4] := J_RUI;
            end;
      end;
      label1.Caption := nomes[1];
      label2.Caption := nomes[2];
      label3.Caption := nomes[3];
      label4.Caption := nomes[4];
      formResize(Sender);
      Inicializa;
      intJogAbreRodada := 1; { ver isto se  certo }
      intJogadorDaVez := intJogAbreRodada;
      intJogadorAtual := intJogadorDaVez;
      intMaoAtual := 1;
      intPontosD1 := 0; intPontosD2 := 0;
      intMaosD1 := 0; intMaosD2 := 0;
    end;
  timerJogo.Enabled := true;
end;

{############ Limpa a mesa e inicia uma nova rodada }
procedure TformMesa.Inicializa;
var
  valorVira, intX, intY, v, n : integer;
  strNome : string;
begin

  inicializando := true;

  { limpa a mesa }
  Screen.Cursor := crHourGlass;

  for intX := ControlCount-1 downto 0 do
    if Controls[intX] is TCartaTruco then
      begin
        MoveCarta(TCartaTruco(Controls[intX]),cartaBaralho1.Left,cartaBaralho1.Top);
        Controls[intX].free;
      end;

  Paint;
  Update;

  { incializa o baralho }
  for intX := 1 to 13 do
    for intY := 1 to 4 do
      sorteada[intX,intY] := false;

  for intx := 8 to 10 do
    for intY := 1 to 4 do
      sorteada[intX,intY] := true; {tira os 8, 9 e 10 do baralho }

  { distribui as cartas. So 4 conjuntos de 3 cartas, dando uma por vez pra
    cada jogador }
  for intX := 1 to 3 do
    for intY := 1 to 4 do
      begin
        // Pega uma carta ainda no sorteada
        repeat
          v := Random(13)+1; n := Random(4)+1;
        until not sorteada[v,n];
        strNome := 'J'+IntToStr(intY)+'C'+IntToStr(intX);
        sorteada[v,n] := true;
        // Cria o objeto da carta
        // A posio inicial  a do baralho (i.e., a de cartaBaralho1)
        with TCartaTruco.Create(Self) do
          begin
            Visible := false;
            Name := strNome;
            Parent := Self;
            Mostrar := false;
            TipoBaralho := cartaBaralho1.TipoBaralho;
            Color := clGreen;
            valor := v;
            naipe := n;
            left := cartaBaralho1.Left;
            top := cartaBaralho1.Top;
            Jogador := intY;
            Visible := True;
            OnClick := CartaClick;
            mao := 0;
          end;
        // Permite o redesenho da carta (seno a animao no funciona)
        Application.ProcessMessages;
        // O if abaixo  para o caso do usurio chamar "novo jogo" enquanto
        // as cartas esto sendo distribudas
        if not inicializando then exit;
        // Move a carta para a posio correta, de acordo com o jogador (intY)
        // e a ordem da carta (intX)
        MoveCarta(TCartaTruco(FindComponent(strNome)),PosCartas[intY].x+(intX-1)*14,PosCartas[intY].y);
        // Se for do jogador "console" (1), mostra a carta
        if intY = 1 then TCartaTruco(FindComponent(strNome)).Mostrar := true;
      end;

  { vira o zap (mesmo processo das outras, mas movendo um pouco
    para a esquerda do baralho) }

  repeat
    v := Random(13)+1; n := Random(4)+1;
  until not sorteada[v,n];
  sorteada[v,n] := true;
  if v=3 then
    menorCarta.Valor := 5
  else
    menorCarta.Valor := 4;
  with TCartaTruco.Create(Self) do
    begin
      Visible := false;
      Name := 'J5C1'; {nome s pro resize pegar }
      Parent := Self;
      Mostrar := false;
      TipoBaralho := cartaBaralho1.TipoBaralho;
      Color := clGreen;
      valor := v;
      naipe := n;
      left := cartaBaralho1.Left;
      top := cartaBaralho1.Top;
      Jogador := 0;
      Visible := True;
      mao := 99;
    end;

  MoveCarta(TCartaTruco(FindComponent('J5C1')),cartaBaralho4.left+40,
            cartaBaralho4.top);
  with TCartaTruco(FindComponent('J5C1')) do
    begin
      Mostrar := true;
      SendToBack;
    end;

  // Determina o valor do zap (=valor seguinte ao da carta virada. Ex.: se
  // a carta virada  6, o valor  7, se  K (13), o valor  A (1), considerando
  // que o componente de cartas foi feito pensando em ordem JQK, e o truco usa
  // QJK

  valorVira := v+1;
  if v=10 then valorVira := 12;
  if v=11 then valorVira := 13;
  if v=12 then valorVira := 11;
  if v=13 then valorvira := 1;
  for intX := ComponentCount-1 downto 0 do
    if (components[intX] is TCartaTruco) and (TCartaTruco(components[intX]).valor = valorVira) then
      TCartaTruco(components[intX]).Virada := true;;

  // Valores do incio da mo

  intJogadorTrucando := 0;              { Ningum est trucando }
  intUltimoTrucador := 0;               { Qualquer um pode pedir truco }
  intMaoAtual := 1;                     { Primeira mo da rodada }
  daVezJogou := false;
  tempoMin := 0;
  pontosValendo := 1;
  btnTruco.Enabled := true;
  btnTruco.Caption := 'Truco !';
  btnQueima.Enabled := true;
  btnQueima.Caption := 'Queima';
  panelMensagem.Caption := '';
  timerMensagem.Enabled := True;
  for intX := 1 to 4 do
    begin
      Desistiu[intX] := false;
      ArregouTruco[intX] := false;
    end;
  Screen.Cursor := crDefault;
  inicializando := false;
end;

{############ Move uma carta para qualquer posio, com animao}
procedure TformMesa.MoveCarta(carta : TCartaTruco; x, y : integer);
var
  diag, numPassos, n, passoX, passoY : longint;
  cursorAnterior : TCursor;
begin
  cursorAnterior := screen.cursor;
  screen.Cursor := crHourGlass;
  diag := round(sqrt((longint(y-carta.Top)*longint(y-carta.Top))+
               (longint(x-carta.Left)*longint(x-carta.Left))));
  numPassos := 1+(diag div 30);
  passoX := (x-carta.Left) div numPassos;
  passoY := (y-carta.Top) div numPassos;
  for n := 1 to numPassos do
    begin
      if abs(x-carta.Left)>=abs(passoX) then
        carta.Left := carta.Left + passoX;
      if abs(y-carta.Top)>=abs(passoY) then
        carta.Top := carta.Top + passoY;
      Update;
    end;
  carta.Left := x;
  carta.Top := y;
  Paint;
  Update;
  screen.Cursor := cursoranterior;
end;

{############ Ao quando o jogador clica uma carta }
procedure TformMesa.cartaClick(Sender: TObject);
begin
  if intmaoAtual=0 then exit;
  if TCartaTruco(Sender).mao <> 0 then
    Mensagem('No mexa na mesa !')
  else if TCartaTruco(Sender).Jogador <> 1 then
    Mensagem('Pare de espiar as cartas dos outros !')
  else if intJogadorTrucando <> 0 then
    Mensagem('No  hora de mexer nas cartas !')
  else if intJogadorAtual = 1 then
    begin
      daVezJogou := true;
      TCartaTruco(Sender).mao := intMaoAtual;
      TControl(Sender).BringToFront;
      MandaPraMesa(TCartaTruco(Sender));
      TCartaTruco(Sender).Mostrar := true;
      Inc(intJogadorAtual);
    end
  else
    Mensagem('Calma, parceiro ! Espere a sua vez...');
end;

procedure TformMesa.MandaPraMesa(Sender : TCartaTruco);
var
  x,y : integer;
begin
  repeat
    x := ((ClientWidth-panelMesa.Width) div 2) + Random(panelMesa.Width-71);
    y := ((ClientHeight-panelMesa.Height) div 2) + Random(panelMesa.Height-96);
  until (abs(ultCartaX-x)>15) and (abs(ultCartaY-y)>15);
  MoveCarta(Sender,x,y);
  ultCartaX := x;
  ultCartay := y;
end;

procedure TformMesa.FormCreate(Sender: TObject);
begin
  Randomize;
  intTamMinMesa := (Height-ClientHeight)+423;
  width := intTamMinMesa;
  height := intTamMinMesa;
  panelMesa.Left := (ClientWidth - panelMesa.Width) div 2;
  panelMesa.Top := (ClientHeight - panelMesa.Height) div 2;
  intMaoAtual := 0; tempoMin := 0;
  ultCartaX := 0; ultCartay := 0;
  nomes[2] := 'Abreu';
  nomes[3] := 'Sunda';
  nomes[4] := 'Lochas';
  menorCarta := TCartaTruco.Create(self);
  with menorCarta do
    begin
      visible := false;
      valor := 4;
      naipe := 1;
    end;
end;

procedure TformMesa.timerJogoTimer(Sender: TObject);
var
  c : TCartaTruco;
  intX, intMaiorPeso,
  intJ, intGanhador  : integer;
  msg : string;
begin

  if not inicializando then
    begin

      if Desistiu[1] and Desistiu[3] then intMaosD2 := 999;
      if Desistiu[2] and Desistiu[4] then intMaosD1 := 999;

      if (intMaoAtual > 0) and (intJogadorAtual = intJogadorDaVez) and
         (daVezJogou) then
        begin
          { determina o vencedor da mao}
          daVezJogou := false;
          intMaiorPeso := 0;
          for intJ := 1 to 4 do
            for intX := 0 to ComponentCount-1 do
              if (copy(Components[intX].name,1,2) = 'J'+intToStr(intJ)) and
                 (TCartaTruco(Components[intX]).mao=intMaoAtual) and
                 (TCartaTruco(Components[intX]).Peso > intMaiorPeso) then
                begin
                  intMaiorPeso := TCartaTruco(Components[intX]).Peso;
                  intGanhador := intJ;
                end;
          Mensagem(Nomes[intGanhador]+' fez a mo e torna.');
          if (intGanhador = 1) or (intGanhador = 3) then
            Inc(intMaosD1)
          else
            Inc(intMaosD2);
          intJogadorDaVez := intGanhador;
          intJogadorAtual := intJogadorDaVez;
          Inc(intMaoAtual);
        end;

      { se necessrio, encerra a rodada }
      if (intMaosD1>1) or (intMaosD2>1) then
        begin
          msg := 'Rodada valendo '+intToStr(pontosValendo)+' ponto';
          if pontosValendo > 1 then msg := msg+'s';
          if intMaosD1 > intMaosD2 then
            begin
              Mensagem(msg + ' para a dupla azul !');
              PiscaMensagem(clBlue);
              intPontosD1 := intPontosD1 + pontosValendo;
            end
          else
            begin
              Mensagem(msg + ' para a dupla amarela !');
              PiscaMensagem(clYellow);
              intPontosD2 := intPontosD2 + pontosValendo;
            end;
          if (intPontosD1 > 11) or (intPontosD2 > 11) then
            begin
              if intPontosD1>11 then
                begin
                  formVitoria.color := clBlue;
                  formVitoria.labelVitoria.caption := 'Vitria da dupla azul !!!!';
                end
              else
                begin
                  formVitoria.color := clYellow;
                  formVitoria.labelVitoria.caption := 'Vitria da dupla amarela !!!!';
                end;
              timerJogo.Enabled := false;
              if formVitoria.ShowModal = mrOk then
                begin
                  autoNovoJogo := true;
                  NovoJogo1Click(Sender);
                end
              else
                begin
                  intMaosD1 := 0;
                  intMaosD2 := 0;
                  intMaoAtual := 0;
                end;
              timerJogo.Enabled := true;
              exit;
            end;
          Inicializa;
          Inc(intJogAbreRodada); if intJogAbreRodada > 4 then intJogAbreRodada := 1;
          intJogadorDaVez := intJogAbreRodada;
          intJogadorAtual := intJogadorDaVez;
          intMaosD1 := 0; intMaosD2 := 0;
          timerJogo.Enabled := false; timerJogo.Enabled := true;
        end;

      { faz a jogada do computador }

      while Desistiu[intJogadorAtual] do
        begin
          Inc(intJogadorAtual); if intJogadorAtual > 4 then intJogadorAtual := 1;
          daVezJogou := true;
        end;

      if (intJogadorAtual<>1) and (intMaoAtual > 0) then
        begin
          tempoMin := tempoMin + 1;
          if (tempoMin > 5) and (Random(3)>1.5) then
            begin
              tempoMin := 0;
              c := FazJogada(intJogadorAtual);

              { manda carta pra mesa }
              c.mao := intMaoAtual;
              c.BringToFront;
              MandaPraMesa(c);
              c.Mostrar := true;
              Paint;
              Update;

              { passa a vez  }
              Inc(intJogadorAtual); if intJogadorAtual > 4 then intJogadorAtual := 1;
              daVezJogou := true;
            end;
        end;
    end;
end;

procedure TFormMesa.Mensagem(s : string);
begin
  panelMensagem.Caption := '  '+s;
  panelMensagem.Font.Color := clWhite;
  timerMensagem.Enabled := false;
  timerMensagem.Enabled := true;
end;

procedure TformMesa.timerMensagemTimer(Sender: TObject);
begin
  panelMensagem.Caption := '  '+Nomes[1]+'/'+Nomes[3]+' -> '+intToStr(intPontosD1)+
                           ' x '+intToStr(intPontosD2)+' <- '+Nomes[2]+'/'+Nomes[4];
  panelMensagem.Font.Color := clBlack;
  timerMensagem.Enabled := false;
end;

procedure TformMesa.PiscaMensagem(cor : TColor);
var
  intX : integer;
begin
  label1.show;
  label2.show;
  label3.show;
  label4.show;
  for intX := 1 to 6 do
    with panelMensagem do begin
      Font.Color := clAqua;
      Paint;
      Update;
      pause(50);
      Font.Color := cor;
      Paint;
      Update;
      pause(100);
    end;
end;


procedure TformMesa.btnTrucoClick(Sender: TObject);
begin
  { Se estiver sendo trucado, o boto  pra descer... }
  if intJogadorTrucando in [2,4] then
    AceitaTruco(1)
  { Se  truco mesmo, s deixa trucar se no fomos os ltimos a faz-lo }
  else if intUltimoTrucador in [1,3] then
    Mensagem('Agora no d ! Os caras foram os ltimos a pedir...')
  else
    PedeTruco(1);
end;


procedure TformMesa.btnQueimaClick(Sender: TObject);
begin
  CartaBaralho1.SetFocus;
  if intJogadorTrucando=0 then
    if intMaoAtual<>0 then
      begin
        Desiste(1);
        btnQueima.Enabled := false;
        btnTruco.Enabled := false;
      end
  else
    ArregaTruco(1);
end;

procedure TformMesa.Desiste(jogDesistente : integer);
var
  intX : integer;
begin
  Desistiu[jogDesistente] := true;
  for intX := 0 to ComponentCount-1 do
    if Components[intX] is TCartaTruco then
      with TCartaTruco(Components[intX]) do
        if (Jogador = jogDesistente) and (mao=0) then
          begin
            mostrar := false;
            mao := 999;
            MoveCarta(TCartaTruco(formMesa.components[intX]),cartaBaralho1.Left,cartaBaralho1.Top);
          end;
end;

{ executa as jogadas do computador }
function TformMesa.FazJogada(jog : integer) : TCartaTruco;
var
  intX,intY,intJog : integer;
  intCartaNaMao : integer;
  minhasCartas : TList;
  cartasJogadas : TList;
  boolTrocou : boolean;
begin

  try
    { determina qual  a ordem desta carta na mo }
    intCartaNaMao := jog - intJogadorDaVez + 1;
    while intCartaNaMao < 1 do
      intCartaNaMao := intCartaNaMao + 4;

    { determina as cartas j jogadas }
    cartasJogadas := TList.Create;
    cartasJogadas.Add(nil);
    for intX := 1 to 3 do
      begin
        intJog := intJogadorDaVez+intX-1;
        if intJog > 4 then intJog := intJog-4;
        if Desistiu[intJog] then
          cartasJogadas.Add(menorCarta)
        else
          cartasJogadas.Add(Nil);
      end;
    for intX := 0 to ComponentCount - 1 do
      if (Components[intX] is TCartaTruco) and (TCartaTruco(Components[intX]).mao
          = intMaoAtual) then
        begin
          intY := TCartaTruco(Components[intX]).jogador - intJogadorDaVez + 1;
          while intY < 1 do
            intY := intY + 4;
          if (not Desistiu[TCartaTruco(Components[intX]).jogador]) then
            cartasJogadas[intY] := TCartaTruco(Components[intX]);
        end;

    { coloca as cartas do jogador atual na lista, por ordem de valor }
    minhasCartas := TList.Create;
    for intX := 0 to ComponentCount - 1 do
      if (Components[intX] is TCartaTruco) and (TCartaTruco(Components[intX]).jogador
          = jog) and (TCartaTruco(Components[intX]).mao = 0) then
        minhasCartas.Add(Components[intX]);

    if minhasCartas.Count > 1 then
      repeat
        boolTrocou := false;
        for intX := 1 to minhasCartas.Count-1 do
          if TCartaTruco(minhasCartas[intX-1]).Peso > TCartaTruco(minhasCartas[intX]).Peso then
            begin
              minhasCartas.Exchange(intX-1,intX);
              boolTrocou := true;
            end;
      until not boolTrocou;

    result :=  nil;

    case intMaoAtual of
      1 : case intCartaNaMao of
            1 : begin
                  for intX := 0 to 2 do
                    if TCartaTruco(minhasCartas[intX]).peso < PESO_A then
                      result := TCartaTruco(minhasCartas[intX]);
                  if result = nil then result := TCartaTruco(minhasCartas[0]) {*};
                end;
            2 : begin
                  result := TCartaTruco(minhasCartas[0]); {*}
                  if TCartaTruco(cartasJogadas[1]).peso < PESO_A then
                    for intX := 2 downto 0 do
                      if TCartaTruco(minhasCartas[intX]).peso >
                         TCartaTruco(cartasJogadas[1]).peso then
                        result := TCartaTruco(minhasCartas[intX]); {*}
                end;
            3 : if TCartaTruco(cartasJogadas[1]).peso < TCartaTruco(cartasJogadas[2]).peso then
                  if TCartaTruco(cartasJogadas[2]).peso < PESO_A {*} then
                    begin
                      result := TCartaTruco(minhasCartas[0]);
                      for intX := 2 downto 0 do
                        if TCartaTruco(minhasCartas[intX]).peso >
                           TCartaTruco(cartasJogadas[2]).peso then
                          result := TCartaTruco(minhasCartas[intX]);
                    end
                  else
                    result := TCartaTruco(minhasCartas[0])
                else
                  begin
                    result := TCartaTruco(minhasCartas[0]);
                    if TCartaTruco(cartasJogadas[1]).peso >= PESO_A then
                      for intX := 2 downto 0 do
                        if TCartaTruco(minhasCartas[intX]).peso < PESO_A then
                          result := TCartaTruco(minhasCartas[random(intX)+1]);
                  end;
            4 : if (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[1]).peso) and
                   (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[3]).peso) then
                  result := TCartaTruco(minhasCartas[0])
                else
                  begin
                    if TCartaTruco(cartasJogadas[1]).peso > TCartaTruco(cartasJogadas[3]).peso then
                      intY := TCartaTruco(cartasJogadas[1]).peso
                    else
                      intY := TCartaTruco(cartasJogadas[3]).peso;
                    result := TCartaTruco(minhasCartas[Random(2)]);
                    for intX := 2 downto 0 do
                      if TCartaTruco(minhasCartas[intX]).peso > intY then
                        result := TCartaTruco(minhasCartas[intX]);
                    end;
          end;
      2 : if ((jog in [1,3]) and (intMaosD1>intMaosD2)) or
             ((jog in [2,4]) and (intMaosD1<intMaosD2)) {ganhando} then
            begin
              result := TCartaTruco(minhasCartas[0]) {*};
              if (not (
                 ((intCartaNaMao = 3) and
                 (TCartaTruco(cartasJogadas[1]).peso > TCartaTruco(cartasJogadas[2]).peso))
                 or
                 ((intCartaNaMao = 4) and
                 (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[1]).peso) and
                 (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[3]).peso))
              )) and (TCartaTruco(minhasCartas[0]).peso >= PESO_Q) then
                result := TCartaTruco(minhasCartas[1]);
            end
          else
            begin
              result := TCartaTruco(minhasCartas[1]) {*};
              if ((intCartaNaMao = 3) and (TCartaTruco(cartasJogadas[1]).peso >= PESO_A) and
                 (TCartaTruco(cartasJogadas[1]).peso > TCartaTruco(cartasJogadas[2]).peso))
                 or
                 ((intCartaNaMao = 4) and (TCartaTruco(cartasJogadas[2]).peso >= PESO_A) and
                 (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[1]).peso) and
                 (TCartaTruco(cartasJogadas[2]).peso > TCartaTruco(cartasJogadas[3]).peso))
              then
                result := TCartaTruco(minhasCartas[Random(2)]);
            end;
      3 : result := TCartaTruco(minhasCartas[0]);
    end;
  finally
    minhasCartas.Free;
    cartasJogadas.Free;
  end;
  { ESTRATGIA:
    1) Se for 1a. mao
         Se for a primeira carta, jogar a maior carta que seja menor que A. Se no
             houver nenhuma, jogar a menor de todas - (qualquer fator aleatorio vale aqui)
         Se for a segunda carta,
           Se a carta da 1a. for >= A, jogue sua menor carta (i.e., deixe para o parceiro),
           seno jogue sua menor carta que seja maior que a do adversario - (tambm vale qqer random)
         Se for a terceira carta
           Se estiver perdendo
             Se (a 2a. carta for < A ou fator aleatorio), jogue a menor carta maior que a 2a.,
             senao jogue a menor
           Se estiver ganhando
             Se a 1a. carta for >=A, jogue aleatoriamente qualquer carta menor
              que A (se nao houver nenhuma, jogue a menor),
             senao jogue aletoriamente qualquer carta maior que A (se nao houver
             nenhma, jogue a menor mesmo)
         Se for a quarta carta
           Se estiver ganhando, jogue a menor,
           Se estiver perdendo
              Se tiver duas ou tres cartas para ganhar, jogue a menor delas (com fator aleatorio),
              Se tiver uma so, jogue-a (fator aleatorio)
              Se nao tiver nenhuma, jogue aleatoriamente a menor ou a segunda menor
    2) Se for 2a. mao
          Se ganhou a 1a mao:
             Se ((parceiro esta perdendo) e (menor carta >= Q)) jogar a maior carta,
             seno jogar a menor (com fator aleatrio)
          Se perdeu a 1a mao:
             Se ((parceiro esta ganhando) e (parceiro >= A)) jogar a menor carta (com fator aleatrio),
             seno jogue a maior
    3) Se for 3a. mao
          Jogue a carta da mo, n, man ?
}
end;

procedure TformMesa.timerIndicaJogadorTimer(Sender: TObject);
begin
  if (intMaoAtual>0) and ((intJogadorAtual<>intJogadorDaVez) or not daVezJogou)
    and not Desistiu[intJogadorAtual] then
    begin
      label1.show;
      label2.show;
      label3.show;
      label4.show;
      case intJogadorAtual of
        1 : label1.visible := boolPisca;
        2 : label2.visible := boolPisca;
        3 : label3.visible := boolPisca;
        4 : label4.visible := boolPisca;
      end;
      boolPisca := not boolPisca;
      if boolPisca then
        timerIndicaJogador.Interval := 200
      else
        timerIndicaJogador.Interval := 72;
    end;

end;

procedure TformMesa.Sair1Click(Sender: TObject);
begin
  Close;
end;

procedure TformMesa.EscolherBaralho1Click(Sender: TObject);
begin
  timerJogo.Enabled := false;
  formEscolheBaralho.ShowModal;
  timerJogo.Enabled := true;
end;

procedure TformMesa.btnDebugTrucaClick(Sender: TObject);
begin
  PedeTruco(strtoint(editNumJog.text));
end;

procedure TformMesa.PedeTruco(intJogador : integer);
var
  strJogada : string;
  intX : integer;
begin
  { Conserta a tela }
  label1.show;
  label2.show;
  label3.show;
  label4.show;
  CartaBaralho1.SetFocus;
  { Mostra a mensagem e desabilita o timer de jogo }
  case PontosValendo of
    1 : strJogada := 'TRUCO';
    3 : strJogada := 'SEIS';
    6 : strJogada := 'NOVE';
    9 : strJogada := 'DOZE';
  end;
  Mensagem(Nomes[intJogador]+' pede '+strJogada+' !!!');
  Piscamensagem(clWhite);
  intJogadorTrucando := intJogador;
  intUltimoTrucador := intJogador;
  timerJogo.Enabled := false;
  timerTruco.Enabled := true;
  for intX := 1 to 4 do
    ArregouTruco[intX] := Desistiu[intX];
  if intJogador in [2,4] then
    begin
      btnQueima.Caption := 'Arrega';
      btnTruco.Caption := 'Desce !';
      btnTruco.Enabled := true;
    end
  else
    btnTruco.Enabled := false;
end;

{ Esta procedure  chamada quando algum aceita o truco. Ela atualiza o boto
  de truco, o valor da rodada e prossegue o jogo }

procedure tFormMesa.AceitaTruco(Jogador : integer);
begin
  if PontosValendo = 1 then
    PontosValendo := 3
  else
    PontosValendo := PontosValendo + 3;
  Mensagem(Nomes[Jogador]+' manda descer.');
  PiscaMensagem(clWhite);
  btnTruco.Enabled := (intJogadorTrucando in [2,4]) and (PontosValendo < 12);
  case PontosValendo of
    3 : btnTruco.caption := 'SEIS !';
    6 : btnTruco.caption := 'NOVE !!';
    9 : btnTruco.caption := 'DOZE !!!';
  end;
  intJogadorTrucando := 0;
  timerTruco.Enabled := false;
  timerJogo.Enabled := true;
end;



{ Se houver algum trucando, o jogo no prossegue enquanto os adversrios
  no queimarem/desistirem ou algum deles aceitar. Este timer cuida desta parte }

procedure TformMesa.timerTrucoTimer(Sender: TObject);
var
  a1,a2 : integer; {adversrios do jogador que est trucando }
begin
  a1 := intJogadorTrucando + 1; if a1>4 then a1 := a1-4;
  a2 := intJogadorTrucando + 3; if a2>4 then a2 := a2-4;
  { Executa jogadas do computador }
  if (a1<>1) and (Random(4)>2) and not ArregouTruco[a1] then
    if AvaliaTruco(a1) then
      AceitaTruco(a1)
    else
      ArregaTruco(a1)
  else if (a2<>1) and (Random(4)>1) and not ArregouTruco[a2] then
    if AvaliaTruco(a2) then
      AceitaTruco(a2)
    else
      ArregaTruco(a2);

  { Checa se ambos desistiram. Neste caso, prossegue o jogo (pra encerar) }
  if ArregouTruco[a1] and ArregouTruco[a2] then
    begin
      Desistiu[a1] := true;
      Desistiu[a2] := true;
      timerTruco.Enabled := false;
      timerJogo.Enabled := true;
    end;
end;

{ Esta funo determina se um jogador eletronico deve ou no aceitar o truco }

function TFormMesa.AvaliaTruco(jog : integer) : boolean;
var
  p,totalP,intX : integer;
  notaAceite : real;
  minhasCartas : TList;
  estamosGanhando : boolean;
begin
  notaAceite := 0;
  minhasCartas := TList.Create;
  try
    { coloca as cartas do jogador atual na lista, por ordem de valor }
    for intX := 0 to ComponentCount - 1 do
      if (Components[intX] is TCartaTruco) and (TCartaTruco(Components[intX]).jogador
          = jog) and (TCartaTruco(Components[intX]).mao = 0) then
        minhasCartas.Add(Components[intX]);

    totalP := 0;
    if minhasCartas.Count >= 1 then
      begin
        for intX := 0 to minhasCartas.Count-1 do
          begin
            p := TCartaTruco(minhasCartas.items[intX]).peso;
            if p > PESO_K+1 then
              notaAceite := notaAceite + 1;
            if p >= PESO_A then
              notaAceite := notaAceite + 1;
            if p >= PESO_2 then
              notaAceite := notaAceite + 1;
            if p >= PESO_3 then
              notaAceite := notaAceite + 1;
            totalP := totalP + p;
          end;
        if totalP >= minhasCartas.Count*PESO_J then notaAceite := notaAceite + 1;
        if totalP >= minhasCartas.Count*PESO_A then notaAceite := notaAceite + 2;
        if totalP >= minhasCartas.Count*PESO_3 then notaAceite := notaAceite + 1;
        if pontosValendo = 3 then notaAceite := notaAceite - 0.2;
        if pontosValendo = 6 then notaAceite := notaAceite - 0.4;
        if pontosValendo = 9 then notaAceite := notaAceite - 1;
        estamosGanhando := ((jog in [2,4]) and (intPontosD1 < intPontosD2)) or
                           ((jog in [1,3]) and (intPontosD2 < intPontosD1));
        if (intMaoAtual = 2) and estamosGanhando then
          notaAceite := notaAceite + 1;
        if (intMaoAtual = 3) then
          notaAceite := notaAceite + 1;
        { Faotr de jogador: }
        notaAceite := notaAceite + (tipoJog[jog] / 2);
      end
    else
      if Random(4)>1 then
        notaAceite := 99
      else
        notaAceite := 0;
  finally
    minhasCartas.free;
  end;

  notaAceite := notaAceite + Random - 0.5; {fatorzinho aleatrio, s pra dar o molho}
  result := notaAceite >= 5;

  { ESTRATGIA DE ACEITE: (t meio desataulizada, cheque o cdigo)
  Determinar "nota" de aceite (1 a 10), sendo que:
  cada zap na mo: vale 4 pontos
  cada carta > K de naipe bom na mo: vale 1 ponto
  Se for na 1a. mo: menos 2 pontos
  Se o total das cartas (numrico) >= 3*J: mais um ponto
  Se o total das cartas >= 3*A: mais dois pontos (total 3)
  Se > 3*3: mais dois pontos (total 5)
  Se for 6: menos 1 ponto
  Se for 9: menos 2 pontos
  Se for 12: menos 3 pontos

  Se for 2a. mo e estamos perdendo: menos 1 ponto }

end;

procedure TformMesa.btnDebugAceitaClick(Sender: TObject);
begin
  AceitaTruco(strtoint(editNumJog.text));
end;

procedure TformMesa.btnDebugDesisteClick(Sender: TObject);
begin
  Desiste(strtoint(editNumJog.text));
end;

{ Procedure chamada quando algum jogador arrega do truco }
procedure TformMesa.ArregaTruco(jog : integer);
begin
  ArregouTruco[jog] := true;
end;

procedure TformMesa.AlternaDebugClick(Sender: TObject);
begin
  panelDebug.Visible := not panelDebug.Visible;
  AlternaDebug.Checked := panelDebug.Visible;
end;

procedure TformMesa.SobreoTrucoLadro1Click(Sender: TObject);
begin
  ShowMessage('Truco 0.3 Alpha.'+Chr(10)+'Desenvolvido originalmente por Chester/Stone Age Scanners'+Chr(10)+Chr(10)+'http://stoneagescanners.com/chester');
end;

end.

{ A Desenvolver:

1) Melhorar o aceite de truco do micro: se no tiver nenhuma carta na mo *e*
o parceiro tiver, arregar na hora (i.e., deixar para ele decidir); se nenhum
  dos dois tiver carta na mo, a 
  fator randomico

2) Micro trucar: QUANDO ????

3) Rede

4) Acertos finais }

